%       KOmananal.m

%           Allows user to manually pick peaks of oscillatory responses.
%           Returns the x- and y-positions of manually identified peaks.

function [xval yval]=KOmananal(trace,mean_trace,time,repnum,prestimdur,pulsedur,pulseint,numpeaks)

%% First cell: for troubleshooting KOmananal only 
% %Load file
% close all
% clear all 
% 
% [filename, pathname] = uigetfile('*.wave.KOrec.mat', 'Open file');
% load (fullfile(pathname,filename), '-mat');
% cd(char(pathname))
% time=[1:1:length(response)].*(1000/srate_rec);
% trace=response(1,:);
%% Allow user to pick the first poststimulus peaks in response
xval=[];
yval=[];
filt_trace=medfilt1(trace,10,50);
lookforpeaks=1;
while lookforpeaks==1
    figure
    hold on
    plot(time,trace,'k')
    plot(time,filt_trace,'m')
      plot(time,mean_trace,'b','LineWidth',2)
    xlabel('Time (ms)')
    ylabel('Resp Amp (mV)')
    legend('Recorded response','Filtered response','Mean response')
    xlim([prestimdur+pulsedur-1 prestimdur+pulsedur+20])
    t=strcat('Pick poststimulus peaks: sweep ',num2str(repnum));
    title(t)
    zoom on
    disp([' '])
    disp(['Press any key when ready to pick peaks'])
    pause
    for j=1:numpeaks
        [xwin(j) ywin(j)]=ginput(1);
        pkdist = sqrt(((time-xwin(j)).^2)+((filt_trace-ywin(j)).^2));
        [m,peak(j)] = min(pkdist);
        plot(time(peak(j)),filt_trace(peak(j)),'g*')
    end
    disp([' '])
    correct_peaks=input('Happy with peaks? (y/n)','s');
    if ((correct_peaks~='y')&&(correct_peaks~='n'))
        ask=1;
        while (ask==1)
        correct_peaks=input('y/n required! Happy with peaks? (y/n)','s');
        if ((correct_peaks=='y')||(correct_peaks=='n'))
            ask=0;
        end
        end
    end
    disp([' '])
    if (correct_peaks=='y')
        lookforpeaks=0;
    end
end

xval=peak;
yval=trace(peak);