%
%   KOrecord_2chancorr.m
%       Measures cross-correlation between two recorded channels in KOrecord.m
%
%% Use FFT to determine period of oscillations
% [a,b] = size(response);
% for i=1:a,
%     [fftstats_r(i,:),FR_r(i,:),PdB_r(i,:)] = fftwave(response(i,:)-mean(response(i,:)),srate_rec);
%     [fftstats_s(i,:),FR_s(i,:),PdB_s(i,:)] = fftwave(stimulus(i,:)-mean(stimulus(i,:)),srate_rec);
% end
% PdBm_r = mean(PdB_r);
% semilogx(F_r,PdBm_r,'m-', 'Linewidth', 2);
% minfrq_r = 500;
% [Maxp_r,imax_r] = max(PdBm_r(minfrq_r:end));
% imax_r = imax_r + minfrq_r - 1;
% fftstats_mean_r = F(i,imax_r);


%% Find cross-correlation coefficient in each recording repetition
[a b]=size(response);
% for i=1:a
for i=2
%     [c lags]=xcf(1,0.1,0,response(i,:),stimulus(i,:));
    [c lags]=xcf(1,0.1,0,response(i,:)-mean(response(i,:)),stimulus(i,:)-mean(stimulus(i,:)));
    [maxcoeff(i) maxwhere(i)]=max(c);
    lagsatmax(i)=lags(maxwhere(i));
    figure
    bar(lags,c,'k')
    xlim([-10^4 10^4])
    ylim([-0.1 0.1])
%     figure
%     bar(lags,c,'k')
%     xlabel('Time lag (ms)')
%     ylabel('Cross-correlation coefficient (r^2)')
%     xlim([0 10^4])
%     ylim([0 0.1])
%      figure
%     bar(lags,c,'k')
%     xlabel('Time lag (ms)')
%     ylabel('Cross-correlation coefficient (r^2)')
%     xlim([0 10^4])
%     ylim([-0.1 0])
%      figure
%     bar(lags,c,'k')
%     xlabel('Time lag (ms)')
%     ylabel('Cross-correlation coefficient (r^2)')
%     xlim([-10^4 0])
%     ylim([-0.1 0])
%      figure
%     bar(lags,c,'k')
%     xlabel('Time lag (ms)')
%     ylabel('Cross-correlation coefficient (r^2)')
%     xlim([-10^4 0])
%     ylim([0 0.1])
%     clear c lags
end

%% Average cross-correlation coefficient across reps
mean_coeff=mean(maxcoeff);
std_coeff=std(maxcoeff);
sem_coeff=std_coeff/sqrt(a);
mean_lags=mean(lagsatmax);
std_lags=std(lagsatmax);
sem_lags=std_lags/sqrt(a);
%% Dispay average and standard deviation of cross-correlation coefficients
disp(' ')
disp(['Average maximum cross-correlation coefficient = ' sprintf('%g',mean_coeff)])
disp(' ')
disp(['Standard deviation of maximum cross-correlation coefficient = ' sprintf('%g',std_coeff)])
disp(' ')
disp(['Standard error of maximum cross-correlation coefficient = ' sprintf('%g',sem_coeff)])
disp(' ')
disp(['Average lag corresponding to maximum cross-correlation coefficient = ' sprintf('%g',mean_lags)])
disp(' ')
disp(['Standard deviation of lags = ' sprintf('%g',std_lags)])
disp(' ')
disp(['Standard error of lags = ' sprintf('%g',sem_lags)])
disp(' ')
[mean_coeff
    std_coeff
    sem_coeff
    mean_lags
    std_lags
    sem_lags]