%
%   KOrecord_fft.m
%       Measures frequency power spectrum of recordings for KOrecord_CAB.m
%
[a,b] = size(response);
for i=1:a,
    [fftstats(i,:),F(i,:),PdB(i,:)] = fftwave(response(i,:)-mean(response(i,:)),srate_rec);
end
% [a,b] = size(stimulus);
% for i=1:a,
%     [fftstats(i,:),F(i,:),PdB(i,:)] = fftwave(stimulus(i,:)-mean(stimulus(i,:)),srate_rec);
% end
PdBm = mean(PdB);
semilogx(F,PdBm,'m-', 'Linewidth', 2);
minfrq = 500;
[Maxp,imax] = max(PdBm(minfrq:end));
imax = imax + minfrq - 1;
fftstats_mean = F(i,imax);
semilogx(F(i,imax),PdBm(imax),'mo')
hold off
zoom on
disp(' ')
['PPF = ' sprintf('%0.4f', fftstats_mean) ' Hz']
disp(' ')
F;
% 
% %% Measure FFT of Channel 2 (of paired recordings)
% [a,b] = size(response);
% for i=1:a,
%     [fftstats(i,:),F(i,:),PdB(i,:)] = fftwave(response(i,:)-mean(response(i,:)),srate_rec);
% end
% PdBm = mean(PdB);
% semilogx(F,PdBm,'m-', 'Linewidth', 2);
% minfrq = 500;
% [Maxp,imax] = max(PdBm(minfrq:end));
% imax = imax + minfrq - 1;
% fftstats_mean = F(i,imax);
% semilogx(F(i,imax),PdBm(imax),'mo')
% hold off
% zoom on
% disp(' ')
% ['PPF = ' sprintf('%0.4f', fftstats_mean) ' Hz']
% disp(' ')

%% Also measure oscillation amplitude 
time_rec=[1:1:length(response)].*(1000/srate_rec);
for i=1:a
    filt_response(i,:)=medfilt1(response(i,:),10,50); %10 points=0.10 ms
%     filt_response(i,:)=medfilt1(stimulus(i,:),10,50); %10 points=0.10 ms
    prestimamps(i)=max(filt_response(i,1:round(prestimdur/1000*srate_rec)))-min(filt_response(i,1:round(prestimdur/1000*srate_rec)));
end

mean_prestimamp_byrep=mean(prestimamps);

for i=1:a    
% [allpeaks alltroughs]=peakdet(filt_response(i,:),0.025*mean_prestimamp_byrep);
[allpeaks alltroughs]=peakdet(filt_response(i,1:round(prestimdur/1000*srate_rec)),0.025*mean_prestimamp_byrep);
allpeaks=allpeaks(2:end,:);
[pa pb]=size(allpeaks);
[ta tb]=size(alltroughs);
    if (allpeaks(1,1)<alltroughs(1,1))
        for j=1:(min([pa ta])-1)
            amps(j)=allpeaks(j,2)-alltroughs(j+1,2);
        end
    elseif (allpeaks(1,1)>alltroughs(1,1))
        for j=1:(min([pa ta])-1)
            amps(j)=allpeaks(j+1,2)-alltroughs(j,2);
        end
    end
    mean_amps(i)=mean(amps);
   
    figure
    plot(time_rec,response(i,:),'k')
%     plot(time_rec,stimulus(i,:),'k')
    hold on
    plot(time_rec,filt_response(i,:),'m')
    scatter(time_rec(allpeaks(:,1)),allpeaks(:,2),'b*')
    scatter(time_rec(alltroughs(:,1)),alltroughs(:,2),'g*')
    xlabel('Time (ms)')
    ylabel('Voltage (mV)')
    title(i)
    clear amps allpeaks alltroughs 
end
mean_amps_all=mean(mean_amps);
display('Mean oscillation amplitude (mV)= ')
mean_amps_all
display('SEM oscillation amplitude (mV)= ')
std(mean_amps)/sqrt(10)