%
%   KOrecord_isi.m
%       Measures inter-spike intervals (ISI) for KOrecord_CAB.m
%

%% Select first window for getting first spikes
disp(' ')
wins = input('Enter start of FIRST window (ms): ');
wine = input('Enter end of FIRST window (ms): ');
disp(' ')
%% Make sure spikes are not being double counted in first window
[a b]=size(response);
for i=1:a
    numspksinwin1(i) = length(find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spktimesinwin = spktimes_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spkampsinwin = spkamps_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    if (numspksinwin1(i) > 1)
        disp(' ')
%         delspks=input('More than one spike in window on a single sweep! Delete extra spikes? (y/n)','s');
       delspks='y';
        disp(' ')
        if (delspks=='y')
            % FOR MEASURING POSITIVE PHASE OF SPIKES
            [maxamp maxwhere]=max(spkampsinwin);
            spktimesinwin_byrep1(i)=spktimesinwin(maxwhere);
            spkampsinwin_byrep1(i)=spkampsinwin(maxwhere);
            numspksinwin_byrep1(i)=1;
%           FOR MEASURING NEGATIVE PHASE OF SPIKES:
%             [minamp minwhere]=min(spkampsinwin);
%             spktimesinwin_byrep1(i)=spktimesinwin(minwhere);
%             spkampsinwin_byrep1(i)=spkampsinwin(minwhere);
%             numspksinwin_byrep1(i)=1;
        elseif (delspks=='n')
            spktimesinwin_byrep1(i)=spktimesinwin(1);
            spkampsinwin_byrep1(i)=spkampsinwin(1);
            numspksinwin_byrep1(i)=numspksinwin(i);
        end
    elseif (numspksinwin1(i)==1)
        spktimesinwin_byrep1(i)=spktimesinwin;
        spkampsinwin_byrep1(i)=spkampsinwin;
        numspksinwin_byrep1(i)=1;
    elseif (numspksinwin1(i)==0)
        spktimesinwin_byrep1(i)=NaN;
        spkampsinwin_byrep1(i)=NaN;
        numspksinwin_byrep1(i)=0;
    end
    clear spktimesinwin spkampsinwin
end
%% Select second window for getting first spikes
disp(' ')
wins = input('Enter start of SECOND window (ms): ');
wine = input('Enter end of SECOND window (ms): ');
disp(' ')
%% Make sure spikes are not being double counted in second window
[a b]=size(response);
for i=1:a
    numspksinwin2(i) = length(find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spktimesinwin = spktimes_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spkampsinwin = spkamps_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    if (numspksinwin2(i) > 1)
        disp(' ')
%         delspks=input('More than one spike in window on a single sweep! Delete extra spikes? (y/n)','s');
        delspks='y';
        disp(' ')
        if (delspks=='y')
            % FOR MEASURING POSITIVE PHASE OF SPIKES
            [maxamp maxwhere]=max(spkampsinwin);
            spktimesinwin_byrep2(i)=spktimesinwin(maxwhere);
            spkampsinwin_byrep2(i)=spkampsinwin(maxwhere);
            numspksinwin_byrep2(i)=1;
%           FOR MEASURING NEGATIVE PHASE OF SPIKES:
%             [minamp minwhere]=min(spkampsinwin);
%             spktimesinwin_byrep2(i)=spktimesinwin(minwhere);
%             spkampsinwin_byrep2(i)=spkampsinwin(minwhere);
%             numspksinwin_byrep2(i)=1;
        elseif (delspks=='n')
            spktimesinwin_byrep2(i)=spktimesinwin(1);
            spkampsinwin_byrep2(i)=spkampsinwin(1);
            numspksinwin_byrep2(i)=numspksinwin(i);
        end
    elseif (numspksinwin2(i)==1)
        spktimesinwin_byrep2(i)=spktimesinwin;
        spkampsinwin_byrep2(i)=spkampsinwin;
        numspksinwin_byrep2(i)=1;
    elseif (numspksinwin2(i)==0)
        spktimesinwin_byrep2(i)=NaN;
        spkampsinwin_byrep2(i)=NaN;
        numspksinwin_byrep2(i)=0;
    end
    clear spktimesinwin spkampsinwin
end
%% Measure interspike interval for each repetition
clear isi
for i=1:a
    if ((~isnan(spktimesinwin_byrep1(i))&&(~isnan(spktimesinwin_byrep2(i)))))
        isi(i)=spktimesinwin_byrep2(i)-spktimesinwin_byrep1(i);
    elseif ((isnan(spktimesinwin_byrep1(i)))||(isnan(spktimesinwin_byrep2(i))))
        isi(i)=NaN;
    end
end
isi
avg_ISI=nanmean(isi);

%% Count spikes in second window only if spikes occurred in first window
spksin2given1=0;
numspksinwin_byrep1
numspksinwin_byrep2
for i=1:a
    if ((numspksinwin_byrep1(i)==1)&&(numspksinwin_byrep2(i)==1))
    spksin2given1=spksin2given1+1;
    end
end

%% Display average interspike interval
disp(' ')
disp(['  Average interspike interval = ' sprintf('%g',avg_ISI) ' ms'])
disp(' ')
disp([' Standard error of interspike interval = ' sprintf('%g',std(isi(~isnan(isi)))/sqrt(sum(~isnan(isi)))) ' ms'])
disp(' ')
%% Display number of spikes in each window
disp(' ')
disp(['  Number of spikes in first window = ' sprintf('%g',sum(numspksinwin_byrep1)) ' spikes'])
disp(' ')
disp(['  Number of spikes in second window = ' sprintf('%g',sum(numspksinwin_byrep2)) ' spikes'])
disp(' ')
disp(['  Number of spikes to second pulse given a spike to first pulse = ' sprintf('%g',spksin2given1) ' spikes'])
disp(' ')