%
%   KOrecord_spkcount.m
%       Counts spikes for KOrecord.m
%

%%
samptime = [1:1:length(response)].*(1000/srate_rec);
%% If stimulus = EOD waveform, determine start and end
if (pulsetype(1)=='L')
    load (wavfilename);
    time_stm=[1:length(stimwave)].*(1000/srate);
    prestimval=mean(stimwave(1:length(stimwave/10)));
    stimwave=stimwave-prestimval;
    stimamp=max(stimwave)-min(stimwave);
    %Define EOD start and end using 2% of peak to peak amplitude criterion.
    %Use absolute value of mean stimulus to accomodate negative and
    %positive phases.
%     figure
%     plot(time_stm,abs(stimwave))
%     hold on
%     plot([time_stm(1) time_stm(end)],[0.02*stimamp 0.02*stimamp],'r-')
   
EODstart_stm=find(abs(stimwave)>(0.02*stimamp),1)-1
EODend_stm=find(abs(stimwave)>(0.02*stimamp),1,'last')+1
EODstart_stmtime=time_stm(EODstart_stm);
EODend_stmtime=time_stm(EODend_stm);
if (isempty(pulsedur))
    pulsedur=EODend_stmtime-EODstart_stmtime;
end
pad=EODstart_stmtime;
[q r]=size(stimulus);
% figure
% hold on
% for i=1:q
%     plot(time_rec,stimulus(i,:),'k')
% end
% plot([EODstart_stmtime+prestimdur EODstart_stmtime+prestimdur],[min(stimulus(1,:)) max(stimulus(1,:))],'g')
% plot([EODend_stmtime+prestimdur EODend_stmtime+prestimdur],[min(stimulus(1,:)) max(stimulus(1,:))],'r')
% xlabel('Time (ms)')
% ylabel('Stimulus amplitude')
% title('Stimulus: black=stimuli, green=start, red=end')
disp([' '])
disp(['Natural EOD stimulus start time = ' sprintf('%g',EODstart_stmtime+prestimdur) ' ms']);
disp([' '])
disp(['Natural EOD stimulus end time = ' sprintf('%g',EODend_stmtime+prestimdur) ' ms']);
disp([' '])
end
%% Select a window for getting spike counts
disp(' ')
wins = input('Enter start of window (ms): ');
wine = input('Enter end of window (ms): ');
disp(' ')
%% Make sure spikes are not being double counted
[a b]=size(response);
smoothed_response = medfilt1(response',5)';
[m n]=size(spktimes_byrep);
for i=1:a
    for j=2:n
        if ((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
[m n]=size(spktimes_byrep);
for i=1:a
    for j=2:n
        if((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
       if ((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
       if ((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
       if ((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
        if ((spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5)&&(spktimes_byrep(i,j)~=0)&&(spktimes_byrep(i,j-1)~=0)))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end


%% Plot peaks
plot(handles.axes_response,samptime,response,'k-',spktimes_byrep,spkamps_byrep,'g*')
ylabel(handles.axes_response,'Resp Amp (mV)','FontSize',12)
set(handles.axes_response,'XTickLabel',[])
[bincount,bincentr] = hist(spktimes,[0:0.2:max(samptime)]);
bar(handles.axes_spikes,bincentr,bincount,'k')
% axes(handles.axes_spikes)
% lm = line([0 last_pre_bin],[baseline_mean baseline_mean]);
% ls1 = line([0 last_pre_bin],[baseline_mean+baseline_std baseline_mean+baseline_std]);
% ls2 = line([0 last_pre_bin],[baseline_mean+(2*baseline_std) baseline_mean+(2*baseline_std)]);
% ls3 = line([0 last_pre_bin],[baseline_mean+(3*baseline_std) baseline_mean+(3*baseline_std)]);
% ls4 = line([0 last_pre_bin],[baseline_mean+(4*baseline_std) baseline_mean+(4*baseline_std)]);
% set(lm,'Color','r','LineWidth',2)
% set(ls1,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls2,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls3,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls4,'Color','r','LineWidth',2,'LineStyle',':')
ylabel(handles.axes_spikes,'Nnumber of Spikes','FontSize',12)
set(handles.axes_spikes,'XTickLabel',[])
zoom reset
zoom on
%% Make sure spikes are not being double counted within measurement window
[a b]=size(response);
for i=1:a
    numspksinwin(i) = length(find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spktimesinwin = spktimes_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spkampsinwin = spkamps_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    if (numspksinwin(i) > 1)
%         disp(' ')
%         delspks=input('More than one spike in window on a single sweep! Delete extra spikes? (y/n)','s');
%         disp(' ')
delspks='n';
        if (delspks=='y')
            % FOR MEASURING POSITIVE PHASE OF SPIKES
            [maxamp maxwhere]=max(spkampsinwin);
            spktimesinwin_byrep(i)=spktimesinwin(maxwhere);
            spkampsinwin_byrep(i)=spkampsinwin(maxwhere);
            numspksinwin_byrep(i)=1;
%           FOR MEASURING NEGATIVE PHASE OF SPIKES:
%             [minamp minwhere]=min(spkampsinwin);
%             spktimesinwin_byrep(i)=spktimesinwin(minwhere);
%             spkampsinwin_byrep(i)=spkampsinwin(minwhere);
%             numspksinwin_byrep(i)=1;
        elseif (delspks=='n')
            spktimesinwin_byrep(i)=spktimesinwin(1);
            spkampsinwin_byrep(i)=spkampsinwin(1);
            numspksinwin_byrep(i)=numspksinwin(i);
        end
    elseif (numspksinwin(i)==1)
        spktimesinwin_byrep(i)=spktimesinwin;
        spkampsinwin_byrep(i)=spkampsinwin;
        numspksinwin_byrep(i)=1;
    elseif (numspksinwin(i)==0)
        spktimesinwin_byrep(i)=NaN;
        spkampsinwin_byrep(i)=NaN;
        numspksinwin_byrep(i)=0;
    end
    clear spktimesinwin spkampsinwin
end
% for i=1:a
%     figure
%     plot(samptime,response(i,:),'k')
%     hold on
%     plot(samptime,smoothed_response(i,:),'r')
%     scatter(spktimes_byrep(i,:),spkamps_byrep(i,:),'c*')
%     title(i)
% end
%% Count spikes
% spknum = length(find((spktimes>=wins)&(spktimes<wine)));
spknum=sum(numspksinwin_byrep);

%% Display spike count
disp(' ')
disp(['  Spike Count = ' sprintf('%g',spknum) ' spikes'])
disp(' ')