%
%   KOrecord_spkdelete_CAB.m
%       Deletes spikes for KOrecord_CAB.m
%

%% Determine whether to delete all spikes within a window or to delete a specific spike
disp(' ')
win_sin = input('(w)indow for spike removal or (s)ingle spike removal? ','s');
disp(' ')
if win_sin=='w',
    wins = input('Enter start of window (ms): ');
    wine = input('Enter end of window (ms): ');
    disp(' ')
elseif win_sin=='s',
    numrem = input('Enter number of spikes to remove: ');
    disp(' ')
else
    error('Choose (w)indow or (s)ingle!!!');
    disp(' ')
end

%% Delete spikes
axes(handles.axes_response);
samptime = [1:1:length(response)].*(1000/srate_rec);
if win_sin=='w',
    spkyes = find((spktimes<wins)|(spktimes>wine));
    spktimes = spktimes(spkyes);
    spkamps = spkamps(spkyes);
    [a b]=size(spktimes_byrep);
    for i=1:(a*b)
        if((spktimes_byrep(i)>wins)&&(spktimes_byrep(i)<wine))
            spktimes_byrep(i)=NaN;
            spkamps_byrep(i)=NaN;
        end
    end
elseif win_sin=='s',
    for i=1:numrem,
        [xspk,yspk] = ginput(1);
        spkdist = sqrt(((spktimes-xspk).^2)+((spkamps-yspk).^2));
        [y,spkno] = min(spkdist);
        spktimes = [spktimes(1:spkno-1) spktimes(spkno+1:length(spktimes))];
        spkamps = [spkamps(1:spkno-1) spkamps(spkno+1:length(spkamps))];
        [a b]=size(spktimes_byrep);
        for j=1:a
        spkdist_byrep(j,:) = sqrt(((spktimes_byrep(j,:)-xspk).^2)+((spkamps_byrep(j,:)-yspk).^2));
        end
        [min_byrep xmin_byrep]=min(spkdist_byrep,[],2);
        [y_no x_no]=min(min_byrep);
        spktimes_byrep(x_no,xmin_byrep)=NaN;
        spkamps_byrep(x_no,xmin_byrep)=NaN;
        clear spkdist_byrep min_byrep xmin_byrep y_no x_no
    end
end

%% Plot peaks
plot(handles.axes_response,samptime,response,'k-',spktimes,spkamps,'g*')
ylabel(handles.axes_response,'Resp Amp (mV)','FontSize',12)
set(handles.axes_response,'XTickLabel',[])
[bincount,bincentr] = hist(spktimes,[0:0.5:max(samptime)]);
bar(handles.axes_spikes,bincentr,bincount,'k')
ylabel(handles.axes_spikes,'Nnumber of Spikes','FontSize',12)
set(handles.axes_spikes,'XTickLabel',[])
zoom reset
zoom on