%
%   KOrecord_spkdetect_CAB.m
%       Detect spikes for KOrecord_CAB.m
%
%% Get spike threshold
axes(handles.axes_response);
[x,threshold] = ginput(1);

%% Detect all peaks above threshold
smoothed_response = medfilt1(response',5)';
% A=1;
% B=[1 1];
% smoothed_response=filter(B,A,response);
[a,b] = size(smoothed_response);

samptime = [1:1:length(smoothed_response)].*(1000/srate_rec);
spkind = [];
spktimes = [];
spkamps = [];
spktimes_byrep = [];
spkamps_byrep= [];
for i=1:a
    spkind = find((smoothed_response(i,2:end-1)>smoothed_response(i,1:end-2))&(smoothed_response(i,2:end-1)>=smoothed_response(i,3:end))&(smoothed_response(i,2:end-1)>=threshold)) + 1;
    spktimes = [spktimes samptime(spkind)];
    spkamps = [spkamps response(i,spkind)];
    if ((i==1)||(length(samptime(spkind))==length(spktimes_byrep)))
    spktimes_byrep(i,1:length(spkind))=samptime(spkind);
    spkamps_byrep(i,1:length(spkind))=response(i,spkind);
    clear spkind
    elseif (length(spkind)>length(spktimes_byrep))
        for j=1:(i-1)
            spktimes_byrep(j,(length(spktimes_byrep)+1):length(spkind))=NaN;
            spkamps_byrep(j,(length(spktimes_byrep)+1):length(spkind))=NaN;
        end
        spktimes_byrep(i,1:length(spkind))=samptime(spkind);
        spkamps_byrep(i,1:length(spkind))=response(i,spkind);
        clear spkind
    elseif (length(spkind)<length(spktimes_byrep))
        spktimes_temp=samptime(spkind);
        spktimes_temp((length(spktimes_temp)+1):length(spktimes_byrep))=NaN;
        spktimes_byrep(i,1:length(spktimes_temp))=spktimes_temp;
        spkamps_temp=response(i,spkind);
        spkamps_temp((length(spkamps_temp)+1):length(spkamps_byrep))=NaN;
        spkamps_byrep(i,1:length(spkamps_temp))=spkamps_temp;
        clear spktimes_temp spkind spkamps_temp
    end
%     figure
%     plot(samptime,response(i,:),'k')
%     hold on
%     plot(samptime,smoothed_response(i,:),'r')
%     scatter(spktimes_byrep(i,:),spkamps_byrep(i,:),'g*')
% spktimes_byrep(i,(spktimes_byrep(i,:)==0))=NaN
% spkamps_byrep(i,(spktimes_byrep(i,:)==0))=NaN
end

for i=1:a
    spktimes_byrep(i,(spktimes_byrep(i,:)==0))=NaN;
    spkamps_byrep(i,(spktimes_byrep(i,:)==0))=NaN;
end
% disp('spktimes_byrep')
% spktimes_byrep
%% Bin spikes
% [bincount,bincentr] = hist(spktimes,samptime(1:20:end));
% last_pre_bin = bincentr(max(find(bincentr<=prestimdur)));
% baseline_mean = mean(bincount(1:last_pre_bin));
% baseline_std = std(bincount(1:last_pre_bin));

%% Count spikes
% prespknum = length(find((spktimes>=0)&(spktimes<prestimdur)));
% prespkrate = prespknum/prestimdur
% respspknum = max(bincount);
% respspkrate = respspknum/(bincentr(2)-bincentr(1))

%% Detect all peaks BELOW threshold
% smoothed_response = medfilt1(response',5)';
% [a,b] = size(smoothed_response);
% 
% samptime = [1:1:length(smoothed_response)].*(1000/srate_rec);
% spkind = [];
% spktimes = [];
% spkamps = [];
% spktimes_byrep = [];
% spkamps_byrep= [];
% for i=1:a
%     spkind = find((smoothed_response(i,2:end-1)<smoothed_response(i,1:end-2))&(smoothed_response(i,2:end-1)<=smoothed_response(i,3:end))&(smoothed_response(i,2:end-1)<=threshold)) + 1;
%     spktimes = [spktimes samptime(spkind)];
%     spkamps = [spkamps response(i,spkind)];
%     
%     if ((i==1)||(length(samptime(spkind))==length(spktimes_byrep)))
%     spktimes_byrep(i,1:length(spkind))=samptime(spkind);
%     spkamps_byrep(i,1:length(spkind))=response(i,spkind);
%     clear spkind
%     elseif (length(spkind)>length(spktimes_byrep))
%         for j=1:i
%             spktimes_byrep(j,(length(spktimes_byrep)+1):length(spkind))=NaN;
%             spkamps_byrep(j,(length(spktimes_byrep)+1):length(spkind))=NaN;
%         end
%         spktimes_byrep(i,1:length(spkind))=samptime(spkind);
%         spkamps_byrep(i,1:length(spkind))=response(i,spkind);
%         clear spkind
%     elseif (length(spkind)<length(spktimes_byrep))
%         spktimes_temp=samptime(spkind);
%         spktimes_temp((length(spktimes_temp)+1):length(spktimes_byrep))=NaN;
%         spktimes_byrep(i,1:length(spktimes_temp))=spktimes_temp;
%         spkamps_temp=response(i,spkind);
%         spkamps_temp((length(spkamps_temp)+1):length(spkamps_byrep))=NaN;
%         spkamps_byrep(i,1:length(spkamps_temp))=spkamps_temp;
%         clear spktimes_temp spkind spkamps_temp
%     end
% %     figure
% %     plot(samptime,response(i,:),'k')
% %     hold on
% %     plot(samptime,smoothed_response(i,:),'r')
% %     scatter(spktimes_byrep(i,:),spkamps_byrep(i,:),'g*')
% end
%% Plot peaks
plot(handles.axes_response,samptime,response,'k-',spktimes,spkamps,'g*')
ylabel(handles.axes_response,'Resp Amp (mV)','FontSize',12)
set(handles.axes_response,'XTickLabel',[])
[bincount,bincentr] = hist(spktimes,[0:0.2:max(samptime)]);
bar(handles.axes_spikes,bincentr,bincount,'k')
% axes(handles.axes_spikes)
% lm = line([0 last_pre_bin],[baseline_mean baseline_mean]);
% ls1 = line([0 last_pre_bin],[baseline_mean+baseline_std baseline_mean+baseline_std]);
% ls2 = line([0 last_pre_bin],[baseline_mean+(2*baseline_std) baseline_mean+(2*baseline_std)]);
% ls3 = line([0 last_pre_bin],[baseline_mean+(3*baseline_std) baseline_mean+(3*baseline_std)]);
% ls4 = line([0 last_pre_bin],[baseline_mean+(4*baseline_std) baseline_mean+(4*baseline_std)]);
% set(lm,'Color','r','LineWidth',2)
% set(ls1,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls2,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls3,'Color','r','LineWidth',2,'LineStyle',':')
% set(ls4,'Color','r','LineWidth',2,'LineStyle',':')
ylabel(handles.axes_spikes,'Nnumber of Spikes','FontSize',12)
set(handles.axes_spikes,'XTickLabel',[])
zoom reset
zoom on

% %% Troubleshooting 7/8/13
% [c d]=size(spktimes_byrep);
% for i=1:a
% figure
% plot(samptime,smoothed_response(i,:))
% hold on
% for j=1:d
%     if(spktimes_byrep(i,j)~=NaN)
% plot([spktimes_byrep(i,j) spktimes_byrep(i,j)],[min(smoothed_response(i,:)) max(smoothed_response(i,:))],'r')
%     end
% end
% title(num2str(i))
% end
