%
%   KOrecord_spont.m
%       Measures spontaneous activity for KOrecord_CAB.m
%
%% Make sure spikes are not being double counted
[a b]=size(response);
[m n]=size(spktimes_byrep);
spktimes_byrep(2,:);
for i=1:a
    for j=2:n
        if (spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
[m n]=size(spktimes_byrep);
for i=1:a
    for j=2:n
        if (spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
        if (spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
for i=1:a
    for j=2:n
        if (spktimes_byrep(i,j)<(spktimes_byrep(i,j-1)+0.5))
            [val where]=max(spkamps_byrep(i,(j-1):j));
            timechoices=[spktimes_byrep(i,j-1) spktimes_byrep(i,j)];
            spktimes_byrep(i,j-1)=timechoices(where);
            spkamps_byrep(i,j-1)=val;
            spktimes_byrep(i,j:(end-1))=spktimes_byrep(i,(j+1):end);
            spkamps_byrep(i,j:(end-1))=spkamps_byrep(i,(j+1):end);
            spktimes_byrep(i,end)=NaN;
            spkamps_byrep(i,end)=NaN;
        end
    end
end
%% Plot peaks
samptime = [1:1:length(response)].*(1000/srate_rec);
plot(handles.axes_response,samptime,response,'k-',spktimes_byrep,spkamps_byrep,'g*')
ylabel(handles.axes_response,'Resp Amp (mV)','FontSize',12)
set(handles.axes_response,'XTickLabel',[])
[bincount,bincentr] = hist(spktimes,[0:0.2:max(samptime)]);
bar(handles.axes_spikes,bincentr,bincount,'k')
ylabel(handles.axes_spikes,'Nnumber of Spikes','FontSize',12)
set(handles.axes_spikes,'XTickLabel',[])
zoom reset
zoom on
%% Count spikes over each repetition
[a b]=size(spktimes_byrep);
timetot=(prestimdur+pststimdur+pulsedur); %ms
for i=1:a
    spktimes_byrep(i,(spktimes_byrep(i,:)==0))=NaN;
numspks(i)=b-sum((isnan(spktimes_byrep(i,:))));
spkrate(i)=numspks(i)/timetot*1000;  %spikes/sec
end
mean_spkrate=mean(spkrate);
sem_spkrate=std(spkrate)/sqrt(length(spkrate));
std_spkrate=std(spkrate);
%% Measure interspike intervals in each repetition
for i=1:a
    spktimesforisi=spktimes_byrep(i,~isnan(spktimes_byrep(i,:)));
    isi=diff(spktimesforisi);
    median_isi(i)=median(isi);
    mean_isi(i)=mean(isi);
    coeffvar(i)=cv(isi);
    clear isi spktimesforisi
end
mean_median_isi=mean(median_isi);
mean_mean_isi=mean(mean_isi);
mean_cv=mean(coeffvar);
%% Output
disp(' ')
disp([' Average spike rate = ' sprintf('%g',mean_spkrate) ' spikes/sec'])
disp(' ')
disp([' Mean median interspike interval = ' sprintf('%g',mean_median_isi) ' ms'])
disp(' ')
disp([' Mean mean interspike interval = ' sprintf('%g',mean_mean_isi) ' ms'])
disp(' ')
disp([' Mean coefficient of variation = ' sprintf('%g',mean_cv)])
disp(' ')
disp(' ')
disp('Average spike rate (spikes/sec')
disp('Mean median interspike interval (ms)')
disp('Mean mean interspike interval (ms)')
disp('Mean coefficient of variation')

to_disp=[mean_spkrate; mean_median_isi; mean_mean_isi; mean_cv]