%%
%
%   singlestimanal_IPItrain.m
%       Measures EOD rate (from spike-density function) in response to an
%       IPi train
%      
%% Clear Workspace
clear all
close all
%% Load File
    [filename, pathname] = uigetfile('*.wave.st1.mat', 'Open file');
    load (fullfile(pathname,filename), '-mat');
    cd(char(pathname))
    
    disp(fullfile(pathname,filename))
    
    [a,b] = size(eodtimes);
    nreps=a;
    eodints=diff(eodtimes')*1000;
    h=figure;
    plot(eodtimes(:,2:end)',eodints,'.')
    xlabel('Time (sec)')
    ylabel('IPI (ms)')
    
%% Remove artifact
ask=1;
k=1;
eodtimes_noart=eodtimes;
while (ask==1)
remove_art=input('Remove artifact? (y/n)','s');
    if (remove_art=='y')
        win_sin = input('(w)indow for artifact removal or (s)ingle artifact removal? ','s');
        if (win_sin=='w')
        win1 = input('Start of Artifact Window? (s) ');
        win2 = input('End of Artifact Window? (s) ' );
        for i=1:a,
            i;
            art = min(find((eodtimes(i,:)>=win1)&(eodtimes(i,:)<=win2)));
            if isempty(art)==0,
                art_removed(k)=i;
                k=k+1;
                eodtimes_noart(i,art:end) = [eodtimes_noart(i,(art+1):end) NaN];
                new_ints=diff(eodtimes_noart(i,:))*1000;
                clear new_ints
            end
        end
ask=0;
    elseif (win_sin=='s')
        remove=1;
            zoom on
            disp([' '])
            disp(['Press any key when ready to pick artifacts'])
            pause
            r=1;
        while (remove==1)
            [xrem(r) yrem(r)] = ginput(1)
            r=r+1;
            disp([' '])
            disp(['Press any key when finished picking artifacts'])
            k=waitforbuttonpress;
            if (k==1)
                remove=0;
                for m=1:(r-1)
                    for j=1:a
                        eoddist_byrep(j,:) = sqrt(((eodtimes(j,2:end)-xrem(m)).^2)+((eodints(:,j)'-yrem(m)).^2));
                    end
                    [min_byrep xmin_byrep]=min(eoddist_byrep,[],2);
                    [y_no(m) x_no(m)]=min(min_byrep);
                    art_ind(m)=xmin_byrep(x_no(m))+1;
                    disp('Identified min eoddist')
                    eoddist_byrep(x_no(m),art_ind(m)-1)
                    disp('Identified min eoddist -1')
                    eoddist_byrep(x_no(m),art_ind(m)-2)
                    disp('Identified min eoddist +1')
                    eoddist_byrep(x_no(m),art_ind(m))
                    figure
                    plot(eodtimes(x_no(m),2:end),eodints(:,x_no(m))','k.')
                    hold on
                    plot(eodtimes(x_no(m),xmin_byrep(x_no(m))+1),eodints(xmin_byrep(x_no(m)),x_no(m)),'ro')
                    plot(eodtimes(x_no(m),art_ind(m)),eodints(art_ind(m)-1,x_no(m)),'go')
                    title(num2str(x_no(m)))
                 clear eoddist_byrep min_byrep xmin_byrep art
                end
                askartgood=1;
                eodtimes_noart=eodtimes;
                while askartgood==1
                artgood=input('Artifact(s) identified correctly? (y/n)','s');
                if (artgood=='y')
                    temp=eodtimes_noart;
                    for k=1:a
                        if (~isempty(find(isnan(temp(k,:)),1)))
                        firstnan(k)=find(isnan(temp(k,:)),1);
                        end
                    end
                    for (m=1:(r-1))
                        temp(x_no(m),art_ind(m))=NaN;
                    end
                    
                    for k=1:a
                        subtracted=0;
                        for j=1:length(temp)
                            if (isnan(temp(k,j))&&(j<firstnan(k)))
                                temp(k,(j-subtracted):end)=[temp(k,(j-subtracted+1):end) NaN];
                                subtracted=subtracted+1;
                            end
                        end
                        eodtimes_noart(k,:)=temp(k,:);
                    end
                    eodints_noart=diff(eodtimes_noart)'*1000;
                    askartgood=0;
                elseif (artgood=='n')
                    askartgood=0;
                end       
                end
            end
        end
        ask=0;
        end
    elseif (remove_art=='n')
        ask=0;
        eodtimes_noart=eodtimes;
    end
end
%% Calculate EOD Intervals(ms)
eodints=diff(eodtimes_noart')*1000;

%% Calculate Spike Density Function and Derivative
bin_size = 200;

[a,b] = size(eodtimes);
nreps=a;
 for i=1:a,
    eodtimes_sdf = eodtimes_noart(i,:) + prestimdur;
    [f,d,d2,b] = sdf(eodtimes_sdf,bin_size);  
    desired_samples = ceil((prestimdur + pststimdur + sum(stimints)/1000) * 1000);
    if desired_samples>length(f),
                    f = [f zeros(1,desired_samples-length(f))];
                elseif desired_samples<length(f),
                    f = f(1:desired_samples);
                end
    eod_sdf(i,:) = f;
  end

time_sdf = [1/1000:1/1000:length(eod_sdf)/1000]-prestimdur;
mean_sdf=mean(eod_sdf(1:nreps,:));
std_sdf = std(eod_sdf);
baseline_start = min(find(time_sdf>=(-prestimdur+(bin_size/1000))));
baseline_end = max(find(time_sdf<-(bin_size/1000)));
baseline_mean = mean(mean_sdf(baseline_start:baseline_end));
baseline_std = std(mean_sdf(baseline_start:baseline_end));

%% Define stimulus IPI
if (~isempty(findstr(wavfilename,'0,3m'))||~isempty(findstr(wavfilename,'03ms')))
    ipi=0.3;
elseif (~isempty(findstr(wavfilename,'0,5ms'))||~isempty(findstr(wavfilename,'05ms')))
    ipi=0.5;
elseif (~isempty(findstr(wavfilename,'1ms')))
    ipi=1;
elseif (~isempty(findstr(wavfilename,'5ms')))
    ipi=5;
elseif (~isempty(findstr(wavfilename,'10ms')))
    ipi=10;
elseif (~isempty(findstr(wavfilename,'50ms')))   
    ipi=5;
elseif (~isempty(findstr(wavfilename,'100ms')))
    ipi=100;
elseif (~isempty(findstr(wavfilename,'trim')))
    ipi=0;
end
ipi=0.3;
%% Measure maximum IPI within 1 sec of stimulus
for i=1:nreps
    if (~isempty(find(eodtimes_noart(i,:)>0)))
        start_win_t(i)=find(eodtimes_noart(i,:)>0,1);
    else
        start_win_t=NaN;
    end
        if (~isempty(find(eodtimes_noart(i,start_win_t(i):end)<1,1,'last')))
           end_win_t(i)=find(eodtimes_noart(i,start_win_t(i):end)<(1+9*ipi/1000),1,'last')+start_win_t(i)-1;
        elseif (~isempty(find(eodtimes_noart(i,:)>0,1)))
            end_win_t(i)=find(eodtimes_noart(i,:)>0,1);
        else
            end_win_t(i)=NaN;
        end
    start_win_i(i)=start_win_t(i)-1;
    end_win_i(i)=end_win_t(i)-1;
    if ((~isnan(start_win_i(i)))&&(~isnan(end_win_i(i))))
        [max_ipi(i) max_ipi_where(i)]=max(eodints(start_win_i(i):end_win_i(i),i));
        max_ipi_when(i)=eodtimes_noart(i,max_ipi_where(i)+start_win_i(i));
    else
        max_ipi(i)=NaN;
        max_ipi_when(i)=NaN;
    end
end

mean_max_ipi=nanmean(max_ipi);
sem_max_ipi=nanstd(max_ipi)/sum(~isnan((max_ipi)));
%% EOD Rate(Hz)
fig1 = figure('Name','EOD','NumberTitle','off','Position',[20 100 1100 600],'Color','w'); 
a3 = subplot(211);
plot(a3,eodtimes_noart(:,2:end)',diff(eodtimes_noart')*1000,'.')
hold on
for i=1:nreps
    plot(a3,max_ipi_when(i),max_ipi(i),'ko','LineWidth',2,'MarkerSize',10)
end
xlabel(a3,'Time (s)')
ylabel(a3,'EOD Interval (ms)')
zoom on
a2 = subplot(212);
plot(a2,time_sdf,mean_sdf,'k-',time_sdf, baseline_mean*ones(1,length(time_sdf)),'r', time_sdf,(baseline_mean+3*baseline_std)*ones(1,length(time_sdf)),'r--',time_sdf, (baseline_mean-3*baseline_std)*ones(1,length(time_sdf)),'r--')
xlabel(a2,'Time (s)')
ylabel(a2,'EOD Rate (Hz)')
xlim([min(time_sdf),max(time_sdf)])
zoom on
linkaxes([a2 a3],'x')
hold on

%% Measure SDF max and min within 1 sec of IPI train offset
    start_win=min(find(time_sdf>=((-bin_size/1000))));
    end_win=max(find(time_sdf<((bin_size/1000+1+9*ipi/1000))));
    [sdf_max max_where]=max(mean_sdf(start_win:end_win));
    [sdf_min min_where]=min(mean_sdf(start_win:end_win));
    sdf_max_where=max_where+start_win-1;
    sdf_min_where=min_where+start_win-1;
    sdf_max_when=time_sdf(sdf_max_where);
    sdf_min_when=time_sdf(sdf_min_where);
    plot(sdf_max_when,sdf_max,'co')
    plot(sdf_min_when,sdf_min,'bo')
    plot([time_sdf(start_win) time_sdf(start_win)],[min(mean_sdf) max(mean_sdf)],'g--')
    plot([time_sdf(end_win) time_sdf(end_win)],[min(mean_sdf) max(mean_sdf)],'g--')

%% Measure SDF area above (below) prestim mean +(-) 3SD
if (sdf_max>(baseline_mean+3*baseline_std))
    sdf_max_start_where=-1*find(mean_sdf(sdf_max_where:-1:1)<(baseline_mean+3*baseline_std),1,'first')+sdf_max_where+1;
    sdf_max_end_where=find(mean_sdf(sdf_max_where:end)<(baseline_mean+3*baseline_std),1)+sdf_max_where-1;
    max_area=sum(mean_sdf(sdf_max_start_where:sdf_max_end_where)-(baseline_mean+3*baseline_std))/1000;
else
    sdf_max_start_where=NaN;
    sdf_max_end_where=NaN;
    max_area=0;
end
if (sdf_min<(baseline_mean-3*baseline_std))
    sdf_min_start_where=-1*find(mean_sdf(sdf_min_where:-1:1)>(baseline_mean-3*baseline_std),1,'first')+sdf_min_where+1;
    sdf_min_end_where=find(mean_sdf(sdf_min_where:end)>(baseline_mean-3*baseline_std),1,'first')+sdf_min_where+1;
    min_area=sum(mean_sdf(sdf_min_start_where:sdf_min_end_where)-(baseline_mean-3*baseline_std))/1000;
else
    sdf_min_start_where=NaN;
    sdf_min_end_where=NaN;
    min_area=0;
end
    if (~(max_area==0))
        plot(time_sdf(sdf_max_start_where),mean_sdf(sdf_max_start_where),'c+')
        plot(time_sdf(sdf_max_end_where),mean_sdf(sdf_max_end_where),'c*')
    end
    if (~(min_area==0))
        plot(time_sdf(sdf_min_start_where),mean_sdf(sdf_min_start_where),'b+')
        plot(time_sdf(sdf_min_end_where),mean_sdf(sdf_min_end_where),'b*')
    end

plusthreshsdf=(mean_sdf>(baseline_mean+3*baseline_std)).*mean_sdf;
plusbase=(mean_sdf<(baseline_mean+3*baseline_std)).*(baseline_mean+3*baseline_std);
plussdf=plusthreshsdf+plusbase;
minusthreshsdf=(mean_sdf<(baseline_mean-3*baseline_std)).*mean_sdf;
minusbase=(mean_sdf>(baseline_mean-3*baseline_std)).*(baseline_mean-3*baseline_std);
minussdf=minusthreshsdf+minusbase;
plusarea=sum(plussdf(start_win:end_win)-(baseline_mean+3*baseline_std))/1000;
minusarea=sum(minussdf(start_win:end_win)-(baseline_mean-3*baseline_std))/1000;
plot(time_sdf,plussdf,'b')
plot(time_sdf,minussdf,'c')
    
%% Display results
disp(['Baseline EOD rate (Hz) = ' sprintf('%g',baseline_mean)])
disp(['Baseline EOD rate SD (Hz) = ' sprintf('%g',baseline_std)])
disp(['Time of SDF max (s) = ' sprintf('%g',sdf_max_when)])
disp(['SDF max (Hz) = ' sprintf('%g',sdf_max)])
disp(['Time of SDF min (s) = ' sprintf('%g',sdf_min_when)])
disp(['SDF min (Hz) = ' sprintf('%g',sdf_min)])
disp(['Mean maximum IPI within 1 sec poststimulus (ms) = ' sprintf('%g',mean_max_ipi)])
disp(['SEM of maximim IPI within 1 sec poststimulus (ms) =' sprintf('%g',sem_max_ipi)])
disp(['Area of maximum response above baseline + 3SD (including SDF max) =' sprintf('%g',max_area)])
disp(['Area of minimum response below baseline - 3SD (including SDF min)=' sprintf('%g',min_area)])
disp(['Area of response above baseline + 3SD  =' sprintf('%g',plusarea)])
disp(['Area of response below baseline - 3SD =' sprintf('%g',minusarea)])


    clear filename pathname 

    todisp=[baseline_mean baseline_std sdf_max_when sdf_max sdf_min_when sdf_min mean_max_ipi sem_max_ipi max_area min_area plusarea minusarea]'
